/*:
 * @plugindesc Skip the title scene for testing purpose.
 * @version 1.0
 */

/*:ja
 * @plugindesc テストプレイ用にタイトルシーンを飛ばすことができます。
 * @version 1.0
 */

(function() {

    Scene_Boot.prototype.start = function() {
        Scene_Base.prototype.start.call(this);
        SoundManager.preloadImportantSounds();
        if (DataManager.isBattleTest()) {
            DataManager.setupBattleTest();
            SceneManager.goto(Scene_Battle);
        } else {
            this.checkPlayerLocation();
            DataManager.setupNewGame();
            SceneManager.goto(Scene_Map);
        }
        this.updateDocumentTitle();
    };

})();
